#include	"libps.h"

// based on  Dodger of CREATURE sample
// DonE forget to visit our page at http://www.in-brb.de/~creature/

/********************************************************/
#define i_reg  (volatile unsigned short*)0x1F801070
#define i_mask (volatile unsigned short*)0x1F801074
#define spu_mvol_l (volatile unsigned short*)0x1F801D80 
#define spu_mvol_r (volatile unsigned short*)0x1F801D82 
#define sp0 (volatile unsigned short*)0x1F801DAA // flag
#define sp1 (volatile unsigned short*)0x1F801DAE // status 
#define spu_keyON_1 (volatile unsigned short*)0x1F801D88 
#define spu_keyON_2 (volatile unsigned short*)0x1F801D8A
#define spu_keyOFF_1 (volatile unsigned short*)0x1F801D8C
#define spu_keyOFF_2 (volatile unsigned short*)0x1F801D8E
#define cd_mvol_l (volatile unsigned short*)0x1F801DB0 
#define cd_mvol_r (volatile unsigned short*)0x1F801DB2 
#define voice_base (volatile unsigned short*)0x1F801C00
#define spu_sb_addr (volatile unsigned short*)0x1F801DA6
#define spu_delay (volatile unsigned short*)0x1F801014 
#define spu_u_1 (volatile unsigned short*)0x1F801D84 // reverberation depth left
#define spu_u_2 (volatile unsigned short*)0x1F801D86 // reverberation depth right
#define spu_u_3 (volatile unsigned short*)0x1F801D98 
#define spu_u_4 (volatile unsigned short*)0x1F801D9A 
#define spu_u_5 (volatile unsigned short*)0x1F801DB4 
#define spu_u_6 (volatile unsigned short*)0x1F801DB6 
#define spu_u_7 (volatile unsigned short*)0x1F801D90
#define spu_u_8 (volatile unsigned short*)0x1F801D92
#define spu_u_9 (volatile unsigned short*)0x1F801D94 
#define spu_u_A (volatile unsigned short*)0x1F801D96
#define spu_u_B (volatile unsigned short*)0x1F801DAC
#define spu_u_D (volatile unsigned short*)0x1F801DA8
#define spu_u_E (volatile unsigned short*)0x1F801DA2
#define spu_dma_1 (volatile long*)0x1F8010C0
#define spu_dma_2 (volatile long*)0x1F8010C4
#define spu_dma_3 (volatile long*)0x1F8010C8
#define d_pcr (volatile long*)0x1F8010F0
#define d_icr (volatile long*)0x1F8010F4
#define t1_mode (volatile long*)0x1F801114
/********************************************************/

void SPUgly_enable(void)
{
	*sp0 = 0xC000 ; // Enable playing sound
}

int SPUgly_init(void)
{
	short status,c,*p;

	*d_pcr|=0xB0000;  // enable data transfer through SPU dma channels  
	*spu_mvol_r=0x3FFF; // set main volume  
	*spu_mvol_l=0x3FFF;
	*sp0=0x0; // reset spu
	SPUgly_wait();
	*spu_u_B=0x4;
	*spu_u_1=0x0;  // set reverberation depth
	*spu_u_2=0x0; 
	*spu_keyOFF_1 = 0xFFFF ; // set all voices off 
	*spu_keyOFF_2 = 0xFFFF ; 
	*spu_u_3=0x0; 
	*spu_u_4=0x0;
	*spu_u_7=0x0; 
	*spu_u_8=0x0; 
	*spu_u_9=0x0; 
	*spu_u_A=0x0;
	*cd_mvol_l=0x0; // set cd main volume 
	*cd_mvol_r=0x0;
	*spu_u_5=0x0; 
	*spu_u_6=0x0; 
	status=*sp1 & 0x7FF;
	*spu_sb_addr=0x200;
	SPUgly_wait();
	for (c=0;c<8;c++) *spu_u_D=0x0707;
	SPUgly_wait();
	if (*sp1 & 0x400)
	for (c=0;*sp1 & 0x400;c++)
		if (c>3841) {
			printf ("SPU:T/O ... (wait [WRDY H-> L])");
			return -1;
		}
	SPUgly_wait();
	SPUgly_wait();
	*sp0 = *sp0 & 0xFFCF ; 
	if (status!=*sp1 & 0x7FF)
		for (c=0;status!=*sp1 & 0x7FF;c++)
	if (c>3841)
	{
		printf ("SPU:T/O ... (wait [DMAF CLEAR/W])"); // DMA flag clear wait 
		return -1;
	}

	// set voices on off
	*spu_keyON_1 = 0xFFFF ;
	*spu_keyON_2 = 0xFF ;
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	*spu_keyOFF_1 = 0xFFFF ;
	*spu_keyOFF_2 = 0x00FF ;
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	*sp0 = 0x8000 ;// set spu on
	*spu_u_E = 0x1FFF;
}

int SPUgly_setkey(short to,long mask)
{

	switch (to) {
	case 0 : // OFF
		*spu_keyOFF_1 = mask & 0xFFFF ; 
		*spu_keyOFF_2 = mask >> 16    ; 
		break;
	case 1 : // ON
		*spu_keyON_1 = mask & 0xFFFF ; 
		*spu_keyON_2 = mask >> 16    ;
		break;
	}

	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
}

int SPUgly_wait(void)
{
	int c;
	long vara=13;

	// wait for some clock cycles
	for (c=0;c<0x60;c++)
		vara = ( (vara << 1)+vara ) << 2 + vara ; // *13

	if (*sp1 & 0x7FF) // if spu isnt ready then wait
		for (c=0;*sp1 & 0x7FF;c++)
			if (c>3841) // thats too long 
				{  printf (" SPUgly_wait :  SPU fuckEd up .. wait (reset)\n");return 0;}
}
/********************************************************/

/*

    Non-DMA SPU write, hacked by bITmASTER@bigfoot.com
    v0.1                              
*/

char *SpuWrite( char *addr, int size, int spu_addr )
{
   	volatile short *spu = (short *) 0x1f801c00;
#define SPU_ADDR 0x1a6 / 2
#define SPU_DATA 0x1a8 / 2
#define SPU_CTRL 0x1aa / 2
#define SPU_STAT 0x1ae / 2
	short spu_status; 
    int block_size;
    short *ptr;
    short d;
    int i, time_out;
    
	spu_status = spu[SPU_STAT] & 0x7ff;
	spu[SPU_ADDR] = spu_addr >> 3;
	wait();
    ptr = (short *) addr;
    
	while( size > 0 ) {
		block_size = ( size > 64 ) ? 64 : size; 
		for( i = 0; i < block_size; i += 2 )
			spu[SPU_DATA] = *ptr++;     
			
     	d = spu[SPU_CTRL];
     	d = ( d & 0xffcf ) | 0x10;
     	spu[SPU_CTRL] = d;				// write Block to SPU-Memory
		wait();
		     	
     	time_out = 0;
    	while( spu[SPU_STAT] & 0x400 ) {
    		time_out++;
    		if ( time_out == 3840 ){
    			return( "SPU:T/O wait (wrdy H -> L)\n" );
    		}
    	}
    	wait();
    	wait(); 	
		size -= block_size;
	}     
	
	spu[SPU_CTRL] &= 0xffcf;
	
	time_out = 0;
	while( ( spu[SPU_STAT] & 0x7ff ) != spu_status ) {
		time_out++;
    	if ( time_out == 3840 ){
    		return( "SPU:T/O dmaf clear/W\n" );
    	}
    }			 
	return( 0 );
}

int wait( void )
{
	int i;
	
	for ( i = 0; i < 100; i++ );
		
	return( 0 );
}
/********************************************************/

/*
 * `
 */
static void InitDrawEnv()
{
	// rfIMݒ
	SetVideoMode(MODE_NTSC);

	// ʃ[hݒ
	GsInitGraph(320, 240, (0 | GsOFSGPU), 0, 0);
	GsDefDispBuff(0, 0, 0, 240);
}

/*
 * TEh֘A
 */
static void InitSound()
{
}

void SPUTest(void)
{
	int i;
	short ADSRvolumes[60];
	short *spVolumeL = (short *)0x1f801c00;
	short *spVolumeR = (short *)0x1f801c02;
	short *spPitch = (short *)0x1f801c04;
	short *spStartAddress = (short *)0x1f801c06;
	unsigned short *spADSR1 = (unsigned short *)0x1f801c08;
	unsigned short *spADSR2 = (unsigned short *)0x1f801c0a;
	short *spADSRvolume = (short *)0x1f801c0c;

	short *spVoiceOn1 = (short *)0x1f801d88;
	short *spVoiceOff1 = (short *)0x1f801d8c;
	short *spChannelOn1 = (short *)0x1f801d9c;

	short *spSPUControl = (short *)0x1f801daa;
	short *spSPUStatus2 = (short *)0x1f801dae;

	unsigned short AttackSlope  = 0x0;
	unsigned short AttackRate   = 0x7f;
	unsigned short DecayRate    = 0xf;
	unsigned short SustainLevel = 0xf;
	unsigned short SustainSlope = 0x0;
	unsigned short SustainMode  = 0x0;
	unsigned short SustainRate  = 0x7f;
	unsigned short ReleaseSlope = 0x0;
	unsigned short ReleaseRate  = 0x0;

	short VoiceNumber;

	int sb_addr = 0x10000;
	long SPUTrans[256];

	int size = 1024;

	SPUgly_init();
	SPUgly_enable();

	//////////////////////////////////////////////////////////////////
	// g`f[^SPUobt@ɓ]

	// ]郁C̃obt@
	memset(SPUTrans, 0, 1024); // 0NA
	SPUTrans[252] = 0x00000700; // ŌVAGubN[v(gGfBA?)

/*
	*d_pcr |= 0xB0000 ; // SPU DMAonɂ
	*spu_sb_addr = sb_addr >> 3; // TEhobt@̃AhX̐錾

	// [h̐錾 : CPUSPU
	*sp0 = *sp0 & 0xFFCF | 0x20;
	*spu_delay = *spu_delay & 0xF0FFFFFF | 0x20000000;

	// DMA`l̏Ɠ]Jn
	*spu_dma_1 = (long)SPUTrans; // ǂݏ郁C̃AhX
	if (size & 0x3F > 0) {i=1;}else{i=0;}
	*spu_dma_2 = (size>>6 + i)<<16 | 0x10;

	// ]Jn : CPUSPU
	*spu_dma_3 = 0x01000201;

	// ]I܂ő҂
	while (*spu_dma_3 & 0x01000000) {};
*/
	SpuWrite((char *)SPUTrans, 1024, sb_addr);
 	//////////////////////////////////////////////////////////////////

	// {CX1̊ep[^ݒ
	*spVolumeL = (short)0x3fff;
	*spVolumeR = (short)0x3fff;
	*spPitch = (short)0x1000;
	*spStartAddress = (short)sb_addr >> 3;
	*spADSR1 = (AttackSlope << 15) | (AttackRate << 8) | (DecayRate << 4) | (SustainLevel);
	*spADSR2 = (SustainSlope << 15) | (SustainMode << 14) | (SustainRate << 6) | (ReleaseSlope << 5) | (ReleaseRate);
	printf("Set voice parameter done.\n");

	// 1b҂(Ӗ͖)
	for(i = 0;i < 60;i++)
		VSync(0);

	printf("*spChannelOn1 = %x\n", *spChannelOn1);
	printf("*spADSRvolume = %x\n", *spADSRvolume);
	*spVoiceOn1 = (short)0x0001;
	printf("*spChannelOn1 = %x\n", *spChannelOn1);
	printf("*spADSRvolume = %x\n", *spADSRvolume);

	// 1bԂADSR{[̐ڂۑ
	for(i = 0;i < 60;i++)
	{
		VSync(0);
		ADSRvolumes[i] = *spADSRvolume;
	}

	*spVoiceOff1 = (short)0x0001;
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	SPUgly_wait();
	printf("*spChannelOn1 = %x\n", *spChannelOn1);
	printf("*spADSRvolume = %x\n", *spADSRvolume);

	for(i = 0;i < 60;i++)
	{
		printf("ADSRvolumes[%i]:%i\n", i, ADSRvolumes[i]);
	}
}

int main(int argc,char **argv)
{
	printf("start main().\n");

	/* `̏ */
	InitDrawEnv();
	printf("InitDrawEnv() done.\n");

	/* TEh֘Ȁ */
//	InitSound();
//	printf("InitSound() done.\n");

	SPUTest();
	printf("SPUTest() done.\n");
//	for(;;);
}
